package ru.dbotthepony.mc.otm.screen;

public enum UVWindingOrder {
	U0_V0_U1_V1(0, 1, 2, 3), // normal operation
	U0_V1_U1_V0(0, 3, 2, 1), // mirror y
	U1_V0_U0_V1(2, 1, 0, 3), // mirror x
	U1_V1_U0_V0(2, 3, 0, 1); // mirror both

	public static final int U0 = 0;
	public static final int V0 = 1;
	public static final int U1 = 2;
	public static final int V1 = 3;

	public final int u0;
	public final int v0;
	public final int u1;
	public final int v1;

	private final float[] uv_map = new float[4];

	UVWindingOrder(int u0, int v0, int u1, int v1) {
		this.u0 = u0;
		this.v0 = v0;
		this.u1 = u1;
		this.v1 = v1;
	}

	public UVCoords translate(float u0, float v0, float u1, float v1) {
		uv_map[0] = u0;
		uv_map[1] = v0;
		uv_map[2] = u1;
		uv_map[3] = v1;

		return new UVCoords(uv_map[this.u0], uv_map[this.v0], uv_map[this.u1], uv_map[this.v1]);
	}
}
