package ru.dbotthepony.mc.otm.screen.panels;

import ru.dbotthepony.mc.otm.screen.MatteryScreen;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class DraggableCanvasPanel extends EditablePanel {
	public DraggableCanvasPanel(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y, float width, float height) {
		super(screen, parent, x, y, width, height);
		scissor = true;
	}

	public DraggableCanvasPanel(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent) {
		super(screen, parent);
		scissor = true;
	}

	protected boolean dragging = false;
	protected double last_mouse_x;
	protected double last_mouse_y;

	@Override
	protected boolean mouseClickedInner(double mouse_x, double mouse_y, int flag) {
		dragging = true;
		last_mouse_x = mouse_x;
		last_mouse_y = mouse_y;
		setIgnoreMouseEventBoundaries(true);
		return true;
	}

	@Override
	protected boolean mouseReleasedInner(double mouse_x, double mouse_y, int flag) {
		dragging = false;
		setIgnoreMouseEventBoundaries(false);
		return true;
	}

	@Override
	protected boolean mouseDraggedInner(double mouse_x, double mouse_y, int flag, double drag_x, double drag_y) {
		if (dragging) {
			x_offset -= last_mouse_x - mouse_x;
			y_offset -= last_mouse_y - mouse_y;

			last_mouse_x = mouse_x;
			last_mouse_y = mouse_y;
		}

		return true;
	}
}
